class PcConnection extends React.Component
{
  constructor(props)
  {
    super(props);
    this.opened = false;
    this.mainDiv = React.createRef();

    this.state = {visible:false};

    PcConfig.onConnectionChange = (c) => {this.setState({visible:!c});};
  }

  onClickMain(e)
  {
    if (e.type === 'touchend')
    {
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    console.log("EXEC: Win10: Show Available Networks");
    let exec = require('child_process').exec;
    PcConfig.electron.send('windowBack');
    exec("Start ms-availablenetworks:"); // windows 10: show available networks
  }

  render()
  {
    if (!this.state.visible) return null;

    if (PcConfig.scenario.buttonsStyle=="rounded")
    {
      var borderRadius = 12 * PcConfig.renderSize;
    }
    else if (PcConfig.scenario.buttonsStyle=="roundedMore")
    {
      var borderRadius = 36 * PcConfig.renderSize;
    }
    else if (PcConfig.scenario.buttonsStyle=="square")
    {
      var borderRadius = 0;
    }

    let iconSize = (PcConfig.renderSize*30)+"px";
    let iconUrl = PcConfig.host + "/ressources/icon_disconnected.png";
    let icon = "<div style='display:inline-block; width:"+iconSize+"; height:"+iconSize+"; background-color:"+PcConfig.scenario.langButtonTextColor+"; -webkit-mask-image:url("+iconUrl+"); -webkit-mask-size:"+iconSize+" "+iconSize+";'></div>";

    let mainTitle = "<div style='display:flex; align-items:center; justify-content:flex-end'>" + icon + "</div>";

    return e('div',
      {
        ref:this.mainDiv,
        className:"pclanguagescontainer",
        onClick:(e)=>{this.onClickMain(e)},
        onTouchEnd:(e)=>{this.onClickMain(e)},
        tabIndex:0,
        style:{
          position:"absolute",
          backgroundColor:PcConfig.scenario.langButtonBackgroundColor,
          fontFamily:PcConfig.scenario.fontFamily,
          fontSize:PcConfig.scenario.fontSizeMedium,
          color:PcConfig.scenario.langButtonTextColor,
          borderStyle:"solid",
          borderWidth:PcConfig.scenario.buttonsBorderWidth/4,
          borderColor:PcConfig.scenario.langButtonBorderColor,
          borderRadius:borderRadius,
          padding:PcConfig.renderSize*10,
          right:PcConfig.renderSize*20,
          bottom:-PcConfig.renderSize*10,
          textAlign:"right",
          outline:"none",
        },
      },
      e('div',
        {
          style:{
              margin:PcConfig.renderSize*10,
          },
          dangerouslySetInnerHTML:{__html:mainTitle}
        }
      )
    );
  }
}
