class PcScreenPreviewVideo extends PcScreen
{
  constructor(props)
  {
    super(props);

    this.buttons = [];
    this.buttons["previous"] = React.createRef();
    this.buttons["next"] = React.createRef();

    this.registerButton(this.buttons["previous"], PcConfig.screen.preview.previousButton.title);
    this.registerButton(this.buttons["next"], PcConfig.screen.preview.nextButton.title);
  }

  normalizeButtons()
  {
    if (this.props.active) setTimeout(()=>{this.normalizeButtonsWidth()}, 10);
  }

  componentDidMount()
  {
      this.normalizeButtons();
  }

  componentDidUpdate()
  {
      this.normalizeButtons();
  }

  render()
  {
    if (!this.props.active) return null;

    let videoFile = PcConfig.getMemory('recordedVideoFile');

    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:this.props.noAnimation?"":this.state.animationStyle
        },
      },
      e(PcMedia,
        {
          content:PcConfig.screen.preview.foreground,
          width:this.props.width,
          height:this.props.height,
        }
      ),
      e(PcLabel,
        {
          label:PcConfig.screen.preview.title,
          width:this.props.width,
          height:this.props.height*(0.1),
          x:0,
          y:this.props.height*(0.03),
          fontSize:PcConfig.scenario.fontSizeBig,
          color: PcConfig.scenario.fontColor,
          showDelay:"0,1s"
        }
      ),
      e(PcVideoPlayer,
        {
          file:videoFile,
          foreground:PcConfig.screen.menu.themes[PcConfig.getMemory("currentTheme")].maskPreviewPicture,
          display: (this.props.active ? 'block' : 'none'),
          width:1280 * PcConfig.renderSize,
          height:720 * PcConfig.renderSize,
          x:(this.props.width - (1280 * PcConfig.renderSize))/2,
          y:(this.props.height - (720 * PcConfig.renderSize))/2,
          showDelay:"0.2s"
        }
      ),
      e('div',
        {
          style:
            {
              position:"absolute",
              width:"50%",
              top:"85%",
              left:"25%",
              height:"15%",
              display:"inline-flex",
              justifyContent: "space-evenly",
              alignItems:"center",
              alignContent:"space-around",
            }
        },
        e(PcButton,
          {
            ref:this.buttons["previous"],
            label:PcConfig.screen.preview.previousButton.title,
            fontColor:PcConfig.screen.preview.previousButton.fontColor,
            borderColor:PcConfig.screen.preview.previousButton.borderColor,
            backgroundColor:PcConfig.screen.preview.previousButton.backgroundColor,
            align:"right",
            onClick:this.props.goPrevScreen,
            sound : PcConfig.sounds.button,
            showDelay:"0.3s"
          }
        ),
        e(PcButton,
          {
            ref:this.buttons["next"],
            label:PcConfig.screen.preview.nextButton.title,
            fontColor:PcConfig.screen.preview.nextButton.fontColor,
            borderColor:PcConfig.screen.preview.nextButton.borderColor,
            backgroundColor:PcConfig.screen.preview.nextButton.backgroundColor,
            kind: "action",
            onClick:this.props.goNextScreen,
            sound : PcConfig.sounds.button,
            showDelay:"0.4s"
          }
        )
      )
    );
  }
}
